﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using FCS.Common;
using FCS.Models;
using FCS.Models.Entity;

namespace FCS.Interface
{
    public class CommonJob
    {
        public CommonJob()
        {
            CommonHelper.IpList = new List<string>();
            log = new LogHelper();
            services = IOC.Resolve<IDTOpenCode>();
        }
        /// <summary>
        ///     配置信息
        /// </summary>
        protected FCSConfig Config;

        /// <summary>
        ///     日志对象
        /// </summary>
        protected LogHelper log;

        /// <summary>
        ///     数据服务
        /// </summary>
        protected IDTOpenCode services;

        /// <summary>
        /// 线程总数
        /// </summary>
        protected int threadCount = 0;
        /// <summary>
        /// 完成线程数
        /// </summary>
        protected int finishcount = 0;
        /// <summary>
        /// lock锁
        /// </summary>
        protected object locker = new object();
        /// <summary>
        /// 用以记录线程（用于阻塞主线程，等待所有任务完成）
        /// </summary>
        protected List<Task> taskList = new List<Task>();

        protected string logName;
        /// <summary>
        /// 实体转换
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="data"></param>
        /// <returns></returns>
        protected T Mapper<T>(object data)
        {
            return AutoMapper.Mapper.DynamicMap<T>(data);
        }
    }
}
