﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace FCS.Models.DTO
{
    public class HtmlParameterDTO
    {
        /// <summary>
        /// Url
        /// </summary>
        public string Url { get; set; }
        /// <summary>
        /// 请求方式
        /// </summary>
        public string Method { get; set; } = "get";
        /// <summary>
        /// 设置默认IP地址
        /// </summary>
        public string IP { get; set; }
        /// <summary>
        /// 超时时间
        /// </summary>
        public int? Timeout { get; set; } = 90 * 1000;
        /// <summary>
        /// 默认连接
        /// </summary>
        public string ContentType { get; set; } = "text/html";
        /// <summary>
        /// 标题
        /// </summary>
        public string Title { get; set; } = string.Empty;
        /// <summary>
        /// 表单提交数据
        /// </summary>
        public Dictionary<string, string> FormData { get; set; }

        /// <summary>
        /// 是否检查空
        /// </summary>
        public bool IsCheckEmpty { get; set; } = true;

        /// <summary>
        /// 最多异常多少IP，就会进入获取在线IP得到html
        /// </summary>
        public int NotIpNumber { get; set; } = 10000;
      
    }
}
