﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FCS.Models
{
    /// <summary>
    /// 新闻实体
    /// </summary>
    public class Base_News
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }
        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; } 
        /// <summary>
        /// 类型（1-新闻2-公告）
        /// </summary>		
        public int? TypeId { get; set; }
        /// <summary>
        /// 父级主键
        /// </summary>		
        public string ParentId { get; set; }
        /// <summary>
        /// 所属类别
        /// </summary>		
        public string Category { get; set; }
        /// <summary>
        /// 所属类别Id
        /// </summary>		
        public string CategoryId { get; set; }
        /// <summary>
        /// 完整标题
        /// </summary>		
        public string FullHead { get; set; }
        /// <summary>
        /// 标题颜色
        /// </summary>		
        public string FullHeadColor { get; set; }
        /// <summary>
        /// 简略标题
        /// </summary>		
        public string BriefHead { get; set; }
        /// <summary>
        /// 作者
        /// </summary>		
        public string AuthorName { get; set; }
        /// <summary>
        /// 编辑
        /// </summary>		
        public string CompileName { get; set; }
        /// <summary>
        /// Tag词
        /// </summary>		
        public string TagWord { get; set; }
        /// <summary>
        /// 关键字
        /// </summary>		
        public string Keyword { get; set; }
        /// <summary>
        /// 来源
        /// </summary>		
        public string SourceName { get; set; }
        /// <summary>
        /// 来源地址
        /// </summary>		
        public string SourceAddress { get; set; }
        /// <summary>
        /// 新闻内容
        /// </summary>		
        public string NewsContent { get; set; }
        /// <summary>
        /// 浏览量
        /// </summary>		
        public int? PV { get; set; }
        ///// <summary>
        ///// 评论数
        ///// </summary>
        //public int? CommentingNum { get; set; }
        /// <summary>
        /// 发布时间
        /// </summary>		
        public string ReleaseTime { get; set; }
        /// <summary>
        /// 排序码
        /// </summary>		
        public int? SortCode { get; set; }
        /// <summary>
        /// 删除标记
        /// </summary>		
        public int? DeleteMark { get; set; } = 0;
        /// <summary>
        /// 有效标志
        /// </summary>		
        public int EnabledMark { get; set; } = 1;
        /// <summary>
        /// 备注
        /// </summary>		
        public string Description { get; set; }
        /// <summary>
        /// 创建日期
        /// </summary>		
        public DateTime? CreateDate { get; set; }
        /// <summary>
        /// 创建用户主键
        /// </summary>		
        public string CreateUserId { get; set; }
        /// <summary>
        /// 创建用户
        /// </summary>		
        public string CreateUserName { get; set; }
        /// <summary>
        /// 修改日期
        /// </summary>		
        public DateTime? ModifyDate { get; set; }
        /// <summary>
        /// 修改用户主键
        /// </summary>		
        public string ModifyUserId { get; set; }
        /// <summary>
        /// 修改用户
        /// </summary>		
        public string ModifyUserName { get; set; }
        /// <summary>
        /// 是否热门
        /// </summary>
        public int? IsHot { get; set; } = 0;
        /// <summary>
        /// 是否置顶
        /// </summary>
        public int? IsStick { get; set; } = 0;
        /// <summary>
        /// 是否推荐
        /// </summary>
        public int? IsRecommend { get; set; } = 0;

       
    }
}
