﻿using System;

namespace FCS.Models
{
    //F_Games
    [Table("F_Games")]
    public class F_Games
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 球队编码
        /// </summary>
        /// <returns></returns>
        public string HomeTeamId { get; set; }
        /// <summary>
        /// 球队编码
        /// </summary>
        /// <returns></returns>
        public string VisitingTeamId { get; set; }
        /// <summary>
        /// 主队全场得分
        /// </summary>
        /// <returns></returns>
        public int? HomeTeamScore_All { get; set; }
        /// <summary>
        /// 客队全场得分
        /// </summary>
        /// <returns></returns>
        public int? VisitingTeamScore_All { get; set; }
        /// <summary>
        /// 主队半场得分
        /// </summary>
        /// <returns></returns>
        public int? HomeTeamScore_Half { get; set; }
        /// <summary>
        /// 客队半场得分
        /// </summary>
        /// <returns></returns>
        public int? VisitingTeamScore_Half { get; set; }
        /// <summary>
        /// 枚举（用以区分是哪个赛事）
        /// </summary>
        /// <returns></returns>
        public string EventType { get; set; }
        /// <summary>
        /// 赛事编码
        /// </summary>
        /// <returns></returns>
        public string EventId { get; set; }
        /// <summary>
        /// 比赛时间
        /// </summary>
        /// <returns></returns>
        public DateTime? StartDateTime { get; set; }
        /// <summary>
        /// 场次
        /// </summary>
        /// <returns></returns>
        public string Session { get; set; }
        /// <summary>
        /// 分组编码
        /// </summary>
        /// <returns></returns>
        public string GroupingId { get; set; }
        /// <summary>
        /// 比赛状态（枚举）为开赛、开始、半场、完赛
        /// </summary>
        /// <returns></returns>
        public string Status { get; set; }
        /// <summary>
        /// 是否加时赛
        /// </summary>
        /// <returns></returns>
        public bool? IsOvertime { get; set; }
        /// <summary>
        /// 赛季
        /// </summary>
        /// <returns></returns>
        public string Season { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        /// <returns></returns>
        public DateTime? CreateDateTime { get; set; }
        /// <summary>
        /// 是否获取指数
        /// </summary>
        /// <returns></returns>
        public bool? IsObtain { get; set; }
        /// <summary>
        /// 热度
        /// </summary>
        /// <returns></returns>
        public int? Heat { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        /// <returns></returns>
        public string Remark { get; set; }
    }
}