﻿using System;

namespace FCS.Models
{
    //F_SixHalf
    public class F_SixHalf
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }

        #region 实体成员
        /// <summary>
        /// 枚举（用以区分是哪个赛事）
        /// </summary>
        /// <returns></returns>
        public string EventType { get; set; }
        /// <summary>
        /// 赛事编码
        /// </summary>
        /// <returns></returns>
        public string EventId { get; set; }
        /// <summary>
        /// 主队编码
        /// </summary>
        /// <returns></returns>
        public string HomeTeamId { get; set; }
        /// <summary>
        /// 客队编码
        /// </summary>
        /// <returns></returns>
        public string VisitingTeamId { get; set; }
        /// <summary>
        /// 主队名称
        /// </summary>
        /// <returns></returns>
        public string HomeTeamName { get; set; }
        /// <summary>
        /// 客队名称
        /// </summary>
        /// <returns></returns>
        public string VisitingTeamName { get; set; }
        /// <summary>
        /// 场次
        /// </summary>
        /// <returns></returns>
        public int? Session { get; set; }
        /// <summary>
        /// 比赛时间
        /// </summary>
        /// <returns></returns>
        public DateTime? StartDateTime { get; set; }
        /// <summary>
        /// 欧赔——胜
        /// </summary>
        /// <returns></returns>
        public double? Compensate_SOdd { get; set; }
        /// <summary>
        /// 欧赔——平
        /// </summary>
        /// <returns></returns>
        public double? Compensate_POdd { get; set; }
        /// <summary>
        /// 欧赔——负
        /// </summary>
        /// <returns></returns>
        public double? Compensate_FOdd { get; set; }
        /// <summary>
        /// 亚盘——主
        /// </summary>
        /// <returns></returns>
        public double? AsianDish_SOdd { get; set; }
        /// <summary>
        /// 亚盘——盘
        /// </summary>
        /// <returns></returns>
        public string AsianDish_Disc { get; set; }
        /// <summary>
        /// 亚盘——客
        /// </summary>
        /// <returns></returns>
        public double? AsianDish_FOdd { get; set; }

        /// <summary>
        /// 半场赛果
        /// </summary>
        /// <returns></returns>
        public string HalfResult { get; set; }
        
        /// <summary>
        /// 赛果
        /// </summary>
        /// <returns></returns>
        public string Result { get; set; }
        /// <summary>
        /// 半场彩果
        /// </summary>
        /// <returns></returns>
        public string HalfColourFruit { get; set; }
        /// <summary>
        /// 彩果
        /// </summary>
        /// <returns></returns>
        public string ColourFruit { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        /// <returns></returns>
        public DateTime? CreateDateTime { get; set; }
        /// <summary>
        /// 排序
        /// </summary>
        /// <returns></returns>
        public int? Sort { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        /// <returns></returns>
        public string Remark { get; set; }
        #endregion
    }
}