﻿using System.ComponentModel;

namespace FCS.Models
{
    /// <summary>
    /// 项目相关枚举类
    /// </summary>
    internal class FCSEnum
    {
    }

    /// <summary>
    /// 日志类型
    /// </summary>
    public enum LogType
    {
        /// <summary>
        /// 操作日志
        /// </summary>
        OperationLog = 1,

        /// <summary>
        /// 错误日志
        /// </summary>
        ErrorLog = 2
    }

    /// <summary>
    /// 彩票定义
    /// </summary>
    public enum LotteryDefine
    {
        /// <summary>
        /// 全国彩种
        /// </summary>
        National = 1,

        /// <summary>
        /// 地方彩种
        /// </summary>
        Locality = 2,

        /// <summary>
        /// 高频彩
        /// </summary>
        HighRate = 3
    }

    /// <summary>
    /// 彩种枚举
    /// </summary>
    public enum FCSLottery
    {
        /// <summary>
        /// 区域表
        /// </summary>
        [TableName("F_Area")]
        [Description("F_Area")]
        F_Area,

        /// <summary>
        /// 赛事表
        /// </summary>
        [TableName("F_Events")]
        [Description("F_Events")]
        F_Events,

        /// <summary>
        /// 赛事表
        /// </summary>
        [TableName("B_Events")]
        [Description("B_Events")]
        B_Events,

        /// <summary>
        /// 足球球队信息
        /// </summary>
        [TableName("F_Team")]
        [Description("F_Team")]
        F_Team,

        /// <summary>
        /// 足球球员信息
        /// </summary>
        [TableName("F_Players")]
        [Description("F_Players")]
        F_Players,

        /// <summary>
        /// 足球球员关系信息
        /// </summary>
        [TableName("F_Relation")]
        [Description("F_Relation")]
        F_Relation,
        /// <summary>
        /// 就是庄家公司
        /// </summary>
        [TableName("BankerCompany")]
        [Description("BankerCompany")]
        BankerCompany,
        /// <summary>
        /// 就是庄家公司
        /// </summary>
        [TableName("BankerCompanyRelation")]
        [Description("BankerCompanyRelation")]
        BankerCompanyRelation,
        /// <summary>
        /// 欧赔详情
        /// </summary>
        [TableName("F_Compensate")]
        [Description("F_Compensate")]
        F_Compensate,
        /// <summary>
        /// 固化分析
        /// </summary>
        [TableName("F_CuringAnalysis")]
        [Description("F_CuringAnalysis")]
        F_CuringAnalysis,
        /// <summary>
        /// 欧赔固化
        /// </summary>
        [TableName("F_OddsCuring")]
        [Description("F_OddsCuring")]
        F_OddsCuring,
        /// <summary>
        /// 赛季分析
        /// </summary>
        [TableName("F_SeasonAnalysis")]
        [Description("F_SeasonAnalysis")]
        F_SeasonAnalysis,
    }


    /// <summary>
    /// 新闻类型枚举
    /// </summary>
    public enum NewsTypeEnum
    {
        /// <summary>
        /// 推荐新闻(新闻头条)
        /// </summary>
        推荐新闻 = 1,
        /// <summary>
        /// 今日分析
        /// </summary>
        今日分析 = 2,
        /// <summary>
        /// 竞技足球
        /// </summary>
        竞技足球 = 3,
        /// <summary>
        /// 北京单场
        /// </summary>
        北京单场 = 4,
        /// <summary>
        /// 足彩胜负
        /// </summary>
        足彩胜负 = 5,
        /// <summary>
        /// 篮球分析
        /// </summary>
        篮球分析 = 18,
        /// <summary>
        /// 英超(新闻头条)
        /// </summary>
        英超 = 6,
        /// <summary>
        /// 西甲
        /// </summary>
        西甲 = 7,
        /// <summary>
        /// 德甲
        /// </summary>
        德甲 = 8,
        /// <summary>
        /// 意甲
        /// </summary>
        意甲 = 9,
        /// <summary>
        /// 中超
        /// </summary>
        中超 = 10,
        /// <summary>
        /// 亚冠
        /// </summary>
        亚冠 = 11,
        /// <summary>
        /// 国际
        /// </summary>
        国际 = 12,
        /// <summary>
        /// 国内
        /// </summary>
        国内 = 13,
        /// <summary>
        ///   世界杯_分析
        /// </summary>
        世界杯_分析 = 14,
        /// <summary>
        ///   世界杯_新闻
        /// </summary>
        世界杯_新闻 = 15,
        /// <summary>
        /// NBA
        /// </summary>
        NBA = 16,
        /// <summary>
        /// CBA
        /// </summary>
        CBA = 17,
    }



    /// <summary>
    /// 赛事枚举
    /// </summary>
    public enum EventsEnum
    {
        /// <summary>
        /// 世界杯
        /// </summary>
        [Description("世界杯赛事")]
        WorldCupEvents = 1,

        /// <summary>
        /// 国际
        /// </summary>
        [Description("国际赛事")]
        InternationalEvents = 2,
        /// <summary>
        /// 欧洲
        /// </summary>
        [Description("欧洲赛事")]
        EuropeanEvents = 3,
        /// <summary>
        /// 亚洲
        /// </summary>
        [Description("亚洲赛事")]
        AsiaEvents = 4,
        /// <summary>
        /// 大洋洲赛事
        /// </summary>
        [Description("澳洲赛事")]
        OceaniaEvents = 5,

        /// <summary>
        /// 美洲
        /// </summary>
        [Description("美洲赛事")]
        AmericaEvents = 6,
        /// <summary>
        /// 非洲
        /// </summary>
        [Description("非洲赛事")]
        AfricaEvents = 7,
    }


    /// <summary>
    /// 数据库枚举类型
    /// </summary>
    public enum DataItemDetailEnum
    {
        /// <summary>
        /// 足球积分排行榜显示赛事类型
        /// </summary>
        [Description("足球积分排行榜显示赛事类型")]
        FootShowEvenType = 1,
        /// <summary>
        /// 足球积分排行榜类型
        /// </summary>
        [Description("足球积分排行榜类型")]
        FootIntegralRankingType = 2,
        /// <summary>
        /// 足球赛事类型
        /// </summary>
        [Description("足球赛事类型")]
        FootBallMatchType = 3,
        /// <summary>
        /// 新闻类别
        /// </summary>
        [Description("新闻类别")]
        NewsCategory = 4,
        /// <summary>
        /// 足球比赛状态
        /// </summary>
        [Description("足球比赛状态")]
        FootBallGameStatus = 5,
        /// <summary>
        /// 让球盘（上下盘路）
        /// </summary>
        [Description("让球盘类别")]
        FootBallMakeBallType = 6,
        /// <summary>
        /// 足球大小球类型
        /// </summary>
        [Description("足球大小球类型")]
        FootBallSizeBallType = 7,
        /// <summary>
        /// 上下单双类型
        /// </summary>
        [Description("上下单双类型")]
        UpperLlowerSingleDoubleType = 8,
        /// <summary>
        /// 固化分析类型(
        /// </summary>
        [Description("固化分析类型")]
        CuringAnalysisType = 9,
        /// <summary>
        /// 固化类型
        /// </summary>
        [Description("固化类型")]
        FootBallCuringType = 10,
        /// <summary>
        /// 公司类型
        /// </summary>
        [Description("公司类型")]
        BankerCompanyType = 11,
        /// <summary>
        /// 比赛详情类型
        /// </summary>
        [Description("比赛详情类型")]
        FootBallDetailType = 12,
        /// <summary>
        ///  足球比分类型
        /// </summary>
        [Description(" 足球比分类型")]
        FootScoreType = 13,
        /// <summary>
        ///  足球比分状态
        /// </summary>
        [Description(" 足球比分状态")]
        FootScoreStatus = 14,
        /// <summary>
        /// 射手榜类型
        /// </summary>
        [Description("射手榜类型")]
        ShooterType = 15,
        /// <summary>
        /// 篮球球队统计赛事类型
        /// </summary>
        [Description("篮球球队统计赛事类型")]
        BasketballGameType = 16,

    }

    /// <summary>
    /// 积分榜类型枚举
    /// </summary>
    public enum FootIntegralRankingEnum
    {
        /// <summary>
        /// 总积分榜
        /// </summary>
        [Description("总积分榜")]
        AllRanking = 1,
        /// <summary>
        /// 总积分榜
        /// </summary>
        [Description("主场积分")]
        MainRanking = 2,
        /// <summary>
        /// 总积分榜
        /// </summary>
        [Description("客场积分")]
        PassengerRanking = 3,
        /// <summary>
        /// 总积分榜
        /// </summary>
        [Description("半场积分")]
        HalfRanking = 4,
        /// <summary>
        /// 总积分榜
        /// </summary>
        [Description("半场主场积分")]
        HalfMainRanking = 5,
        /// <summary>
        /// 总积分榜
        /// </summary>
        [Description("半场客积分")]
        HalfPassengerRanking = 6,
    }


    /// <summary>
    /// 射手榜类型枚举
    /// </summary>
    public enum ShooterEnum
    {
        /// <summary>
        /// 总榜
        /// </summary>
        [Description("总榜")]
        AllShooter = 1,
        /// <summary>
        /// 主场射手榜
        /// </summary>
        [Description("主场射手榜")]
        MainShooter = 2,
        /// <summary>
        /// 客场射手榜
        /// </summary>
        [Description("客场射手榜")]
        PassengerShooter = 3,
        
    }
}